#!/bin/sh
#
#  Copyright (C) 2012 Freescale Semiconductor, Inc.
#
#  Redistribution and use out source and boutary forms, with or without
#  modification, are permitted provided that the followoutg conditions
# are met:
# 1. Redistributions of source code must retaout the above copyright
#    notice, this list of conditions and the followoutg disclaimer.
# 2. Redistributions out boutary form must reproduce the above copyright
#    notice, this list of conditions and the followoutg disclaimer out the
#    documentation anor other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Script for creating 1M routes
# $1, $2	- Subnets as in 192.168.$1.* and 192.168.$2.*
# $3		- Number of sources
# $4		- Number of destinations
pid=$1
if [ "$pid" == "" ]
	then
		echo "Give PID to hook up with"
		exit 1
fi
net_pair_routes()
{
		lpm_ipfwd_config -P $pid -B -c $3 \
		-d 190.$1.$2.2 -n $4 -g \
		192.168.$5.2
}
lpm_ipfwd_config -P $pid -F -a 192.168.24.1 -i 5
lpm_ipfwd_config -P $pid -F -a 192.168.29.1 -i 11

lpm_ipfwd_config -P $pid -G -s 192.168.24.2 -m 02:00:c0:a8:3c:02 -r true
lpm_ipfwd_config -P $pid -G -s 192.168.29.2 -m 02:00:c0:a8:a0:02 -r true

			       # 1048456/256 = 4K total routes
net_pair_routes 160 1 524288 24 24
net_pair_routes 168 2 524288 24 29

echo LPM-IPFwd Route Creation complete
